-- Did you think I was gonna use a single lua script? Too bad!

local function P_DoCybrakdemonDeath(mo)
	mo.flags = $ | MF_NOCLIP
	mo.flags = $ & ~(MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT)

	S_StartSound(nil, sfx_bedie2)
	P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_CYBRAKDEMON_VILE_EXPLOSION)
	mo.z = $+P_MobjFlip(mo)
	P_SetObjectMomZ(mo, 12*mapobjectscale, false)
	S_StartSound(mo, sfx_bgxpld)
	P_InstaThrust(mo, R_PointToAngle2(0, 0, mo.x, mo.y), 14*mapobjectscale)
	mo.hbthreshold = 1
	
	if mo.punt then
		mo.punt.ppzShitCounter = max(0, $-1)
		if Music_Stop and mo.punt and mo.punt == consoleplayer then
			Music_Stop("druid", mo.punt)
		end
	end
end

addHook("MobjDeath", P_DoCybrakdemonDeath, MT_CYBRAKDEMON)

addHook("MobjThinker", function(mobj)
	if (!(mobj.tics & 1)) then
		A_BossScream(mobj, 2, 0)
	end
	-- hack...
	if states[mobj.state].action == A_BrakChase then
		if mobj.reactiontime == 0 then
			S_StartSound(nil, sfx_bewar1 + P_RandomKey(4))
			mobj.reactiontime = TICRATE
		end
	end
	-- Sometimes mr brak doesnt wanna do it :(((
	if not (mobj.target and mobj.target.valid) then
		P_LookForPlayers(mobj, 512*mobj.scale, true)
	end
	if (P_CheckDeathPitCollide(mobj)) then
		P_RemoveMobj(mobj)
		return 
	end
	if (mobj.momz and mobj.z + mobj.momz <= mobj.floorz) then
		S_StartSound(mobj, sfx_befall)
		if (mobj.state != S_CYBRAKDEMON_DIE8) then
			mobj.state = S_CYBRAKDEMON_DIE8
		end
	end
	if (mobj.health <= 0 or mobj.state == mobj.info.deathstate) then
		mobj.hbthreshold = $ or 0
		mobj.hbthreshold = $+1
		if mobj.hbthreshold > TICRATE*3 then
			-- do not do shit further
			mobj.hbdeferDie = true
		end
	end
end, MT_CYBRAKDEMON)

-- Fix napalm bomb not fucking dying
addHook("MobjThinker", function(mo)
	if abs(mo.momz) < mo.scale and mo.fuse then
		mo.fuse = 1
	end
end, MT_CYBRAKDEMON_NAPALM_BOMB_LARGE)